
#ifndef _KXEN_H_
#define _KXEN_H_

#include <kxen_desc.h>

#define HV_SIZE_MIN 512
#define HV_SIZE_MAX (512*1024*1024)

int kxen_setup(void);

void kxen_exit(void);

unsigned char *kxen_alloc_mem(size_t guest_size);

int kxen_run(void);

int kxen_xc_hvmop(unsigned, union kxen_hvmop_arg *);
int kxen_xc_memop(unsigned, union kxen_memop_arg *);
int kxen_xc_domctl(struct xen_domctl *);
int kxen_xc_version(int, void *);
void *kxen_xc_mmapbatch(xen_pfn_t *, int, int, domid_t);
void kxen_xc_munmap(void *, int);
int kxen_xc_keyhandler(const char *);

int xc_hvm_build(int xc_handle, uint32_t domid, int memsize,
                 const char *image_name);

#endif
