
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "kxen-host.h"
// #include "tenkei2.h"
// #include <tk2_ioctl.h>
#include <xen/errno.h>

// static HANDLE tk2_handle;
// BOOLEAN ExitFlag = FALSE;

#if 0
BOOLEAN
LoadBlob(
    PMEMDESC Descriptor
    )
{
    HANDLE blob;
    PVOID buffer;
    LARGE_INTEGER blobSize;
    ULONG bytesRead;

    RtlZeroMemory(Descriptor, sizeof(*Descriptor));

    blob = CreateFile("kxen.elf",
                      GENERIC_READ,
                      FILE_SHARE_READ,
                      NULL,
                      OPEN_EXISTING,
                      0,
                      NULL);
    if (blob == INVALID_HANDLE_VALUE) {
        printf("Open of blob file failed, err %d\n", GetLastError());
        return FALSE;
    }

    if (!GetFileSizeEx(blob, &blobSize)) {
        printf("Failed to get size of blob file, err %d\n", GetLastError());
        return FALSE;
    }

    // Note: We expect HV_SIZE_MAX to be less than 4GB, otherwise we
    // can't interchangably use blobSize.u.LowPart below.

    if ((blobSize.QuadPart < HV_SIZE_MIN) ||
        (blobSize.QuadPart > HV_SIZE_MAX)) {
        printf("Blob file size out of expected range.\n");
        return FALSE;
    }

    buffer = malloc((SIZE_T)blobSize.u.LowPart);
    if (!buffer)
    {
        printf("Failed to allocate %d bytes for blob.\n",
                blobSize.u.LowPart);
        return FALSE;
    }

    if (!ReadFile(blob,
                  buffer,
                  blobSize.u.LowPart,
                  &bytesRead,
                  NULL)) {
        printf("Blob read failed, err %d\n", GetLastError());
        return FALSE;
    }

    if (bytesRead != blobSize.u.LowPart) {
        printf("Size mismatch, read %d bytes, expected %d\n",
               bytesRead,
               blobSize.u.LowPart);
        return FALSE;
    }
    Descriptor->Base = buffer;
    Descriptor->Length = bytesRead;
    CloseHandle(blob);

    printf("Loaded blob, %d bytes.\n", bytesRead);

    return TRUE;
}

BOOLEAN
InstallBlob(
    HANDLE   hDevice,
    PMEMDESC Blob
    )
{
    BOOLEAN result;
    ULONG bytesCopied;

    result = Ioctl(hDevice,
                   TENKEI2CTL_loadhv,
                   Blob->Base,
                   Blob->Length,
                   NULL,
                   0,
                   &bytesCopied);
    free(Blob->Base);
    Blob->Base = NULL;
    Blob->Length = 0;
    printf("Copied %d bytes to kernel space.\n", bytesCopied);
    return result;
}
#endif

int
kxen_setup(void)
{
#if 0
    BOOLEAN result;
    ULONG driverVersion;
    ULONG returnedLength;

    if ((tk2_handle = InitDriver()) == INVALID_HANDLE_VALUE) {
	 return -1;
    }

    result = Ioctl(tk2_handle,
                   TENKEI2CTL_get_ver,
                   NULL,
                   0,
                   &driverVersion,
                   sizeof(driverVersion),
                   &returnedLength);

    if (result) {
        printf("IOCTL GET VERSION returned 0x%08x\n", driverVersion);
    } else {
        printf("IOCTL GET VERSION FAILED, ERROR %d\n", GetLastError());
    }

    return result ? 0 : -1;
#endif
    return 0;
}

void
kxen_exit(void)
{
#if 0
    ExitDriver(tk2_handle);

    //
    // Unload the driver.  Ignore any errors.
    //
    ManageDriver(DRIVER_NAME,
                 NULL,
                 DRIVER_FUNC_REMOVE
	);
#endif
}

unsigned char *
kxen_alloc_mem(size_t guest_size)
{
    unsigned char *guest_mem;

    guest_mem = valloc(guest_size);
    if (guest_mem == NULL)
	goto fail;

#if 0
    result = Ioctl(tk2_handle,
		   TENKEI2CTL_lock_guest_mem,
		   guest_mem,
		   guest_size,
		   NULL,
		   0,
		   &returnedLength);

    printf("IOCTL lock guest mem %s\n", result ? "succeeded" : "FAILED!!!");

    if (!result)
	goto fail;
#endif

    return guest_mem;

  fail:
    if (guest_mem)
	free(guest_mem);
    guest_mem = NULL;
    return NULL;
}

int
kxen_run(void)
{
#if 0
    BOOLEAN result;
    ULONG returnedLength;

    result = Ioctl(tk2_handle,
                   TENKEI2CTL_vcpu_run,
                   NULL, 0, NULL, 0, &returnedLength);
    if (result == 0) {
	destroy_hvm_domain();
	exit(0);
    }
    return !result;
#endif
    return 0;
}

int
kxen_hvm_op(int op, void *InBuffer, unsigned long InLength)
{
#if 0
    ULONG returnValue;

    if (Ioctl(tk2_handle, TENKEI2CTL_hvm_op, InBuffer, InLength, NULL,
                 Op,        // N.B. Coopted OutLength to be hvm op.
                 &returnValue) == 0)
	return -EINVAL;

    return (int)returnValue;
#endif
    return 0;
}

int
kxen_domctl(void *InBuffer, unsigned long InLength)
{
#if 0
    ULONG returnValue;

    if (Ioctl(tk2_handle, TENKEI2CTL_domctl, InBuffer, InLength, NULL,
                0, &returnValue) == 0)
	return -EINVAL;

    return (int)returnValue;
#endif
    return 0;
}

int
kxen_memory_op(int Op, void *InBuffer, unsigned long InLength)
{
#if 0
    ULONG returnValue;

    if (Ioctl(tk2_handle, TENKEI2CTL_memory_op, InBuffer, InLength, NULL,
                 Op,        // N.B. Coopted OutLength to be memory op.
                 &returnValue) == 0)
	return -EINVAL;

    return (int)returnValue;
#endif
    return 0;
}

int
kxen_trigger_keyhandler(unsigned char key)
{
#if 0
    ULONG returnValue;

    if (Ioctl(tk2_handle, TENKEI2CTL_trigger_keyhandler, NULL, (ULONG)key,
	      NULL, 0, &returnValue) == 0)
	return -EINVAL;

    return (int)returnValue;
#endif
    return 0;
}
